/*Simple script to create a mail form within a note*/

address 'blocnotes.rexx'
options results

/*Get the id of the note*/

parse arg id .

ISANOTE id
if result then do     /* Check if the id is valid*/
   INFO id
   infos=COMPRESS(result)        /* Check if the note is empty*/
   if LENGTH(infos)=3 then do
      SETINSTIME 0               /* Initialize default parameters */
      INSERT id ON
      EDIT id ON
      SIZE id 0 0 640 300

      IMPORT id 'UULIB:.signature'  /* Import signature file(only one user, sorry!)*/

      GO id 0 0                   /*Insert To and Subject tags*/
      PRINT id 'To:!nSubject:!N!N'
      GO id 4 0
   end
end
