/*Scroller.rexx v3.7*/
IF POS('blocnotes.rexx' , SHOW('Ports'))=0 THEN do
   say "Sorry, I need Blocnotes. Run it first"
   exit
end

address 'blocnotes.rexx'
options results

/******************************************************************
 Adjust these variables to fit in your system.
******************************************************************/

FName="LetterGothic.font"          /*Font to use*/
FSize=60                           /*Size of the font*/
/*****************************************************************/


GETSCREENDATA
parse VAR result . . ScrW ScrH .

WW=FSize*5
WH=FSize+7
Speed=3

forever=0

if words(Arg(1))<2 then do
   if Arg(1)='?' then do
      say 'USAGE: rx Scroller <times> <string>'
      say 'Maximum length is 70 chars.'
   end
   times=3
   string='USAGE: rx Scroller.rexx <times> <string>.Press a key.'
end
else do
   times=word(arg(1),1)
   if times=0 then forever=1
   if (times=0)|(times>40) then times=2

   p=POS(' ',Arg(1))
   string=RIGHT(Arg(1),LENGTH(Arg(1))-p)
   if LENGTH(string)>70 then do
      string=left(string,70);
   end
end

OPEN TRUNC(ScrW-WW)/2 TRUNC((ScrH-WH)/3) WW WH FONTNAME FName FONTSIZE FSize NOSAVE NOGADGET NOEDIT NOSCROLLER SCREEN 'Workbench'
id=result

if id=0 then do
   say 'Can''t open window.'
   exit
end

SETINSTIME Speed
WORDWRAP id OFF
INHIBIT id ON
ONCLICK EXIT
AA=0

do i=0 to times-1
   CLEAR id
   GO id 1 0
   GO id 10 0
   PRINT id "        "
   if AA=0 then do
      SHOW id
      AA=1
   end
   WASCLICKED id
   if result='1' then break
   PRINT id string
   WASCLICKED id
   if result='1' then break
   PRINT id "          "
   WASCLICKED id
   if result='1' then break
   if forever=1 then i=0
end
CLOSE id
