/*
 *
 * Script name:  ShowHelp.rexx
 * Author:       Franz Hemmer
 * Purpose:      Demonstrate how to activate the help from ARexx.
 * Written:      25.11.92
 * Comments:     You need to have Watcher running.
 *
 */

Options FailAt 100
Options Results
address WATCHER1				/* Address Watcher's ARexx port. */
lf = '0A'x

/*
 * Try to read the window title bar
 */
ShowHelp

IF rc > 0 THEN
  SAY 'Error was 'WATCHER.LASTERROR
ELSE DO
  SAY 'Help now in action...'
END
