#ifndef CODE_H
#define CODE_H


/* Compiler specific stuff */

#ifdef _DCC             /* DICE */

#  define __AMIGADATE__ "("__COMMODORE_DATE__")"

#  define ASM
#  define SAVEDS       __geta4 
#  define STACKARGS    __stkargs
#  define WBMsg        _WBMsg
#  define REG(x)       __ ## x
  
#  define MAIN         _main

#else                           /* SAS */

#  define ASM          __asm
#  define SAVEDS       __saveds
#  define STACKARGS    __stdargs
#  define WBMsg        _WBenchMsg
#  define REG(x)       register __ ## x

#  define MAIN         __main

#endif


#endif
