
#include <libraries/gadtools.h>

#include "yak.h"
#include "gui.h"

#include "yak_locale_strings.h"
#include "Root_Window.h"
#include "Root_Menus.h"

IMPORT BOOL CreateIcons;

struct NewMenu RootNewMenu[] = 
{
    {NM_TITLE, NULL,        NULL, 0, NULL,    NULL},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_OPEN},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_SAVE},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_SAVEAS},
    {NM_ITEM,  NM_BARLABEL, NULL, 0, NULL,    NULL},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_ABOUT},
    {NM_ITEM,  NM_BARLABEL, NULL, 0, NULL,    NULL},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_HIDE},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_QUIT},
    {NM_TITLE, NULL,        NULL, 0, NULL,    NULL},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_DEFAULT},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_LASTSAVED},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_ACTIVE},
    {NM_TITLE, NULL,        NULL, 0, NULL,    NULL},
    {NM_ITEM,  NULL,        NULL, 0, 0L,      (APTR)MD_CREATEICONS},
    {NM_END,   NULL,        NULL, 0, NULL,    NULL}
};


VOID 
InitRootNewMenu (VOID)
{
    RootNewMenu[MDX_PROJECT].nm_Label       = (STRPTR)getString(MENU_PROJECT_STRING);
    RootNewMenu[MDX_OPEN].nm_Label          = (STRPTR)getString(MENU_OPEN_STRING);
    RootNewMenu[MDX_OPEN].nm_CommKey        = (STRPTR)getString(MENU_OPEN_SHORTCUT);
    RootNewMenu[MDX_SAVE].nm_Label          = (STRPTR)getString(MENU_SAVE_STRING);
    RootNewMenu[MDX_SAVE].nm_CommKey        = (STRPTR)getString(MENU_SAVE_SHORTCUT);
    RootNewMenu[MDX_SAVEAS].nm_Label        = (STRPTR)getString(MENU_SAVEAS_STRING);
    RootNewMenu[MDX_SAVEAS].nm_CommKey      = (STRPTR)getString(MENU_SAVEAS_SHORTCUT);
    RootNewMenu[MDX_HIDE].nm_Label          = (STRPTR)getString(MENU_HIDE_STRING);
    RootNewMenu[MDX_HIDE].nm_CommKey        = (STRPTR)getString(MENU_HIDE_SHORTCUT);
    RootNewMenu[MDX_ABOUT].nm_Label         = (STRPTR)getString(MENU_ABOUT_STRING);
    RootNewMenu[MDX_ABOUT].nm_CommKey       = (STRPTR)getString(MENU_ABOUT_SHORTCUT);
    RootNewMenu[MDX_QUIT].nm_Label          = (STRPTR)getString(MENU_QUIT_STRING);
    RootNewMenu[MDX_QUIT].nm_CommKey        = (STRPTR)getString(MENU_QUIT_SHORTCUT);
    RootNewMenu[MDX_EDIT].nm_Label          = (STRPTR)getString(MENU_EDIT_STRING);
    RootNewMenu[MDX_DEFAULT].nm_Label       = (STRPTR)getString(MENU_DEFAULT_STRING);
    RootNewMenu[MDX_DEFAULT].nm_CommKey     = (STRPTR)getString(MENU_DEFAULT_SHORTCUT);
    RootNewMenu[MDX_LASTSAVED].nm_Label     = (STRPTR)getString(MENU_LASTSAVED_STRING);
    RootNewMenu[MDX_LASTSAVED].nm_CommKey   = (STRPTR)getString(MENU_LASTSAVED_SHORTCUT);
    RootNewMenu[MDX_ACTIVE].nm_Label        = (STRPTR)getString(MENU_ACTIVE_STRING);
    RootNewMenu[MDX_ACTIVE].nm_CommKey      = (STRPTR)getString(MENU_ACTIVE_SHORTCUT);
    RootNewMenu[MDX_OPTIONS].nm_Label       = (STRPTR)getString(MENU_OPTIONS_STRING);
    RootNewMenu[MDX_CREATEICONS].nm_Label   = (STRPTR)getString(MENU_CREATEICONS_STRING);
    RootNewMenu[MDX_CREATEICONS].nm_CommKey = (STRPTR)getString(MENU_CREATEICONS_SHORTCUT);
    RootNewMenu[MDX_CREATEICONS].nm_Flags   = CHECKIT | MENUTOGGLE| (CreateIcons ? CHECKED : 0);
}

