#define POINTER_REGISTER 16

#define CS_PTR_WIDTH    13
#define CS_PTR_HEIGHT    9
#define CS_PTR_XOFF     -1
#define CS_PTR_YOFF      0

#define CSTO_PTR_WIDTH    13
#define CSTO_PTR_HEIGHT   15
#define CSTO_PTR_XOFF     -1
#define CSTO_PTR_YOFF      0

struct PointerColors
{
    SHORT colorreg;
    UBYTE red;
    UBYTE green;
    UBYTE blue;
    LONG reset;
    };

struct PointerColors PointerColor[] = {
                                     { POINTER_REGISTER+0, 0, 0, 0, 0 },
                                     { POINTER_REGISTER+1,14, 4, 4, 0 },
                                     { POINTER_REGISTER+2, 0, 0, 0, 0 },
                                     { POINTER_REGISTER+3,15,15, 3, 0 }
				   };

__chip USHORT CSPointer[] = 
   {
   0x0000, 0x0000, /* position control */

   0x8000,   0x8000,    /* #............... */    /* #............... */
   0xe000,   0x6000,    /* .##............. */    /* ###............. */
   0x7800,   0xb800,    /* #.###........... */    /* .####........... */
   0x3e00,   0x5e00,    /* .#.####......... */    /* ..#####......... */
   0x1f80,   0x2f80,    /* ..#.#####....... */    /* ...######....... */
   0x0fe0,   0x17e0,    /* ...#.######..... */    /* ....#######..... */
   0x07f8,   0x0bf8,    /* ....#.#######... */    /* .....########... */
   0x03f8,   0x0400,    /* .....#.......... */    /* ......#######... */
   0x0000,   0x03f8,    /* ......#######... */    /* ................ */

   0x0000, 0x0000 /* next sprite field */

   };


__chip USHORT CSToPointer[] = 
   {
   0x0000, 0x0000, /* position control */

   0x8000,   0x8000,    /* #............... */    /* #............... */
   0xe000,   0x6000,    /* .##............. */    /* ###............. */
   0x7800,   0xb800,    /* #.###........... */    /* .####........... */
   0x3e00,   0x5e00,    /* .#.####......... */    /* ..#####......... */
   0x1f80,   0x2f80,    /* ..#.#####....... */    /* ...######....... */
   0x0fe0,   0x17e0,    /* ...#.######..... */    /* ....#######..... */
   0x07f8,   0x0bf8,    /* ....#.#######... */    /* .....########... */
   0x03f8,   0x0400,    /* .....#.......... */    /* ......#######... */
   0x0000,   0x03f8,    /* ......#######... */    /* ................ */
   0x0000,   0x0000,    /* ................ */    /* ................ */
   0x3cf8,   0x3ef8,    /* ..#####.#####... */    /* ..####..#####... */
   0x1110,   0x1998,    /* ...##..##..##... */    /* ...#...#...#.... */
   0x2220,   0x3330,    /* ..##..##..##.... */    /* ..#...#...#..... */
   0x4440,   0x6660,    /* .##..##..##..... */    /* .#...#...#...... */
   0x8780,   0xc7c0,    /* ##...#####...... */    /* #....####....... */

   0x0000, 0x0000 /* next sprite field */
   };
