/*
 *
 * Script name:  GetTitle.rexx
 * Author:       Franz Hemmer
 * Purpose:      Demonstrate how to get Watcher title bar text.
 * Written:      25.11.92
 * Comments:     You need to have Watcher running.
 *
 */

Options FailAt 100
Options Results
address WATCHER1				/* Address Watcher's ARexx port. */
lf = '0A'x

/*
 * Try to read the window title bar
 */
GetTitle

IF rc > 0 THEN
  SAY 'Error was 'WATCHER.LASTERROR
ELSE DO
  SAY 'Window title is: ' || lf || Result
END
