MODULE YAFWC2;

IMPORT
  y := SYSTEM,

  cx := Commodities,
  ie := InputEvent,

  CtrlC,
  CX,
  sig := Signals;

VAR
  yafwc :CX.Com;
  ctrlC :CtrlC.CtrlC;
  prg :sig.Signals;

  filter :CX.Filter;
  translate: CX.Translate;
  event :ie.InputEvent;

BEGIN
  yafwc := CX.Create(y.ADR("YAFWC\o\o$VER: YAFWC.mod 1.1 (12.09.95)"),
                     y.ADR("YAFWC 1.1 1995 S. Le Breton"),
                     y.ADR("Close window with 'lcommand q'"),
                     {cx.unique, cx.notify}, {},
                     0);
  IF yafwc#NIL THEN
    NEW(filter);
    filter.Init("lcommand q\o|<-User-Configuration-:)-last-char-------->|\o");
    filter.Attach(yafwc.Broker);
    event.class := ie.closewindow;
    NEW(translate);
    translate.Init(event);
    translate.Set(event);
    translate.Attach(filter);
    yafwc.Broker.Activate(TRUE);
  
    NEW(ctrlC);
    ctrlC.Init();
  
    NEW(prg);
    prg.Init();
    IF prg.Add(yafwc)#NIL THEN END;
    IF prg.Add(ctrlC)#NIL THEN END;
    prg.Loop();
  END;

CLOSE
  IF yafwc#NIL THEN yafwc.Delete() END;
END YAFWC2.
