/*
 * pri.c
 * 
 * Simple priority alteration routine for Yak.
 * 
 * MWS, 12-Sep-92
 */
#include <exec/types.h>
#include <exec/tasks.h>
#include <proto/exec.h>

#include "yak.h"
#include "Pri.h"

static LONG priority[2] = {0, 11};

__regargs void
MyPri(UWORD which)
{
        static BOOL firsttime = TRUE;
        LONG oldpri;

        oldpri = SetTaskPri(FindTask(NULL), priority[which]);
        if (firsttime)
        {
                priority[ORIGINAL] = oldpri;
                firsttime = FALSE; 
        }
}
